codeforces Snow Boots

题面

It’s winter on the farm, and that means snow! There are N tiles on the path from the farmhouse to the barn, conveniently numbered 1…N, and tile i is covered in fi feet of snow.

Farmer John starts off on tile 1 and must reach tile N to wake up the cows. Tile 1 is sheltered by the farmhouse roof, and tile N is sheltered by the barn roof, so neither of these tiles has any snow. But to step on the other tiles, Farmer John needs to wear boots!

In his foul-weather backpack, Farmer John has B pairs of boots, numbered 1…B. Some pairs are more heavy-duty than others, and some pairs are more agile than others. In particular, pair i lets FJ step in snow at most si feet deep, and lets FJ move at most di forward in each step.

Unfortunately, the boots are packed in such a way that Farmer John can only access the topmost pair at any given time. So at any time, Farmer John can either put on the topmost pair of boots (discarding his old pair) or discard the topmost pair of boots (making a new pair of boots accessible).

Farmer John can only change boots while standing on a tile. If that tile has f feet of snow, both the boots he takes off AND the boots he puts on must be able to withstand at least f feet of snow. Intermediate pairs of boots which he discards without wearing do not need to satisfy this restriction.

Help Farmer John minimize waste, by determining the minimum number of pairs of boots he needs to discard in order to reach the barn. You may assume that Farmer John is initially not wearing any boots.

Input
The first line contains two space-separated integers N and B (2≤N,B≤250).

The second line contains N space-separated integers. The ith integer is fi, giving the depth of snow on tile i (0≤fi≤109). It’s guaranteed that f1=fN=0.

The next B lines contain two space-separated integers each. The first integer on line i+2 is si, the maximum depth of snow in which pair i can step. The second integer on line i+2 is di, the maximum step size for pair i. It’s guaranteed that 0≤si≤109 and 1≤di≤N−1.

The boots are described in top-to-bottom order, so pair 1 is the topmost pair in FJ’s backpack, and so forth.

Output
The output should consist of a single integer, giving the minimum number of boots Farmer John needs to discard. It’s guaranteed that it will be possible for FJ to make it to the barn.

题意

(这道题似乎有一个hard的数据范围大的版本)
你想从位置1到位置N,每个位置上有雪的高度,然后你有一个靴子栈(就是数据结构里的栈),每双靴子两个属性,一次最多跨越几步和耐雪度(即你穿靴子最多跨越踩多高的雪。)然后你只要你有鞋你就可以扔掉当前的,换栈顶的一双靴,换的时候要满足当前位置的雪小于等于之前以及换之后的靴子的耐雪度。求最少扔掉的靴子数。

分析

一开始想要深搜,结果好像不行。
赛后知道使dp,还是挺容易写出来的。
我们用dp[i]表示i位置以及用了多少双鞋。
遍历每一双靴子,把每一位可以走到的地方打上标记。因为不会用到之前的靴子,所以是OK的。模拟的时候要注意要换的靴子的耐雪度必须大于等于当前雪的高度。最后输出dp[n]-1(因为脚上这双鞋没扔所以-1)

代码

#include<bits/stdc++.h>
using namespace std;
const int INF=0x3f3f3f3f;
typedef long long ll;
int n,b,f[255],d[255],s[255];
int dp[255];//dp[i] 到达i位置时用的鞋子数 0则走不到
int main(){
	int i,j,k,l;
	scanf("%d%d",&n,&b);
	for(i=1;i<=n;i++) scanf("%d",&f[i]);
	for(i=1;i<=b;i++) scanf("%d%d",&s[i],&d[i]);
	memset(dp,0,sizeof(dp));
	dp[1]=1;
	for(i=1;i<=b;i++){
		for(j=1;j<=n;j++){
			if(!dp[j]) continue;
			if(f[j]>s[i]) continue;
			//if(dp[j]==i) continue;
			for(k=1;k<=d[i] && j+k<=n;k++){
				if(f[j+k]>s[i]) continue;
				dp[j+k]=i;
			}
			//printf("%d\n",i);
			//for(l=1;l<=n;l++) printf("%d ",dp[l]);
			//puts(""); 
			if(dp[n]){
				printf("%d\n",dp[n]-1);
				return 0;
			}
		}
	}
	return 0;
}
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值